#ifndef MAINWINDOW_H
#define MAINWINDOW_H

#include <QMainWindow>
#include <QMessageBox>
#include "scene3d.h"
#include <QWidget>
#include <QHBoxLayout>
#include <QVBoxLayout>
#include <QGridLayout>
#include <QPushButton>
#include <QGroupBox>
#include <QLabel>
#include <QDoubleSpinBox>
#include <QVector3D>
#include <QVector>
#include <QMenuBar>
#include <QFileDialog>
#include <QDir>
#include <QDebug>
#include <QLCDNumber>
#include "utils.h"
#include "points.h"
#include <gl/gl.h>
#include <gl/glu.h>
#include "glut.h"
#include "speed.h"

class QDoubleSpinBox;
class Points;
class Speed;

namespace Ui {
class MainWindow;
}

class MainWindow : public QMainWindow
{
    Q_OBJECT
protected:

private:
    Ui::MainWindow *ui;
    QPushButton *buttonDrawPoints;
    QPushButton *buttonDrawSpeed;
    QPushButton *buttonClear;
    QPushButton *buttonStartExample;
    QCheckBox *showPointsF;
    QCheckBox *showPointsV;
    QMenu * mnFile;
    QMenu * mnEdit;
    QMenu * mnService;
    QMenu * mnHelp;
    QAction * saveAction;
    QAction * saveAction1;
    QAction * openActionX;
    QAction * openActionY;
    QAction * openActionZ;
    QAction * showInfo;
    QAction * showTaskInfo;
    QAction * draw1;

    QMenu * mnFileSpeed;
    QMenu * mnEditSpeed;
    QMenu * mnServiceSpeed;
    QMenu * mnHelpSpeed;
    QAction * saveActionSpeed;
    QAction * openActionXSpeed;
    QAction * openActionYSpeed;
    QAction * openActionZSpeed;


    void createMenu();
    void createActions();
    unsigned long N_POINTS;
    unsigned long N_SPEED;
    bool controlPoints;
    bool controlSpeed;
    void getLayout();
    QVector3D ** myPointVector;
    QVector3D ** mySpeedVector;

private slots:
    void showSaveMenu();
    void showSaveMenu1();
    void openFileX();
    void openFileY();
    void openFileZ();
    void drawPoints();
    void showMessage();
    void clear();
    void startExample();
    void openFileSpeedX();
    void openFileSpeedY();
    void openFileSpeedZ();
    void drawSpeed();
    void slotShowPointsF();
    void slotShowPointsV();
    void slotShowInfo();
    void slotShowTaskInfo();
public:
    MainWindow();
    Points* points;
    //Speed* speed;
signals:

};

#endif // MAINWINDOW_H
